﻿#ifndef _WTL_TEST_PLUGIN_H_
#define _WTL_TEST_PLUGIN_H_

#include "MQBasePlugin.h"

class WTLTestPlugin : public MQStationPlugin
{
	friend class CMainDlg;

protected:
	CMainDlg *dlgMain;
	bool m_bActivate;

public:
	bool m_bShowLocal;

public:
	WTLTestPlugin();
	virtual ~WTLTestPlugin();

	// プラグインIDを返す。
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// プラグイン名を返す。
	virtual const char *GetPlugInName(void);
	// ポップアップメニューに表示される文字列を返す。
	virtual const char *EnumString(void);

	// アプリケーションの初期化
	virtual BOOL Initialize();
	// アプリケーションの終了
	virtual void Exit();

	// 表示・非表示切り替え要求
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// 表示・非表示状態の返答
	virtual BOOL IsActivated(MQDocument doc);

	// ドキュメント初期化時
	void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// ドキュメント保存時
	void OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param);
	// 描画時の処理
	void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	// オブジェクトの編集時
	virtual void OnObjectModified(MQDocument doc);
	// カレントオブジェクトの変更時
	virtual void OnUpdateObjectList(MQDocument doc);


	typedef bool (WTLTestPlugin::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	// 面の削除
	bool DeleteFace(MQDocument doc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	virtual bool ExecuteCallback(MQDocument doc, void *option);
};


#endif _WTL_TEST_PLUGIN_H_
